pcl::ndt2d::NDTSingleGrid< PointT > Class Template Reference

Build a set of normal distributions modelling a 2D point cloud, and provide the value and derivatives of the model at any point via the test (...) function. More...

`#include <pcl/registration/impl/ndt_2d.hpp>`

Inheritance diagram for pcl::ndt2d::NDTSingleGrid< PointT >:

## Public Member Functions

| NDTSingleGrid (PointCloudConstPtr cloud, const Eigen::Vector2f &about, const Eigen::Vector2f &extent, const Eigen::Vector2f &step)
ValueAndDerivatives< 3, double > | test (const PointT &transformed_pt, const double &cos_theta, const double &sin_theta) const
| Return the 'score' (denormalised likelihood) and derivatives of score of the point p given this distribution. More...

## Protected Member Functions

NormalDist * | normalDistForPoint (PointT const &p) const
| Return the normal distribution covering the location of point p. More...

## Protected Attributes

Eigen::Vector2f | min_
Eigen::Vector2f | max_
Eigen::Vector2f | step_
Eigen::Vector2i | cells_
Eigen::Matrix< NormalDist, Eigen::Dynamic, Eigen::Dynamic > | normal_distributions_

## Detailed Description

### template<typename PointT>
class pcl::ndt2d::NDTSingleGrid< PointT >

Build a set of normal distributions modelling a 2D point cloud, and provide the value and derivatives of the model at any point via the test (...) function.

Definition at line 219 of file ndt_2d.hpp.

## Constructor & Destructor Documentation

## NDTSingleGrid()

template<typename PointT >

pcl::ndt2d::NDTSingleGrid< PointT >::NDTSingleGrid | ( | PointCloudConstPtr | cloud,
|  | const Eigen::Vector2f & | about,
|  | const Eigen::Vector2f & | extent,
|  | const Eigen::Vector2f & | step
| ) |  |

inline

Definition at line 226 of file ndt_2d.hpp.

References pcl::ndt2d::NormalDist< PointT >::addIdx(), pcl::ndt2d::NDTSingleGrid< PointT >::cells_, pcl::ndt2d::NDTSingleGrid< PointT >::normal_distributions_, and pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint().

## Member Function Documentation

## normalDistForPoint()

template<typename PointT >

NormalDist* pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint | ( | PointT const & | p | ) | const

inline protected

Return the normal distribution covering the location of point p.

Parameters

  [in] | p | a point

Definition at line 275 of file ndt_2d.hpp.

References pcl::ndt2d::NDTSingleGrid< PointT >::cells_, pcl::ndt2d::NDTSingleGrid< PointT >::min_, pcl::ndt2d::NDTSingleGrid< PointT >::normal_distributions_, and pcl::ndt2d::NDTSingleGrid< PointT >::step_.

Referenced by pcl::ndt2d::NDTSingleGrid< PointT >::NDTSingleGrid(), and pcl::ndt2d::NDTSingleGrid< PointT >::test().

## test()

template<typename PointT >

ValueAndDerivatives<3,double> pcl::ndt2d::NDTSingleGrid< PointT >::test | ( | const PointT & | transformed_pt,
|  | const double & | cos_theta,
|  | const double & | sin_theta
| ) |  | const

inline

Return the 'score' (denormalised likelihood) and derivatives of score of the point p given this distribution.

Parameters

  [in] | transformed_pt | Location to evaluate at.
  [in] | cos_theta | sin(theta) of the current rotation angle of rigid transformation: to avoid repeated evaluation
  [in] | sin_theta | cos(theta) of the current rotation angle of rigid transformation: to avoid repeated evaluation

Definition at line 260 of file ndt_2d.hpp.

References pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint(), pcl::ndt2d::NormalDist< PointT >::test(), and pcl::ndt2d::ValueAndDerivatives< N, T >::Zero().

## Member Data Documentation

## cells_

template<typename PointT >

Eigen::Vector2i pcl::ndt2d::NDTSingleGrid< PointT >::cells_

protected

Definition at line 293 of file ndt_2d.hpp.

Referenced by pcl::ndt2d::NDTSingleGrid< PointT >::NDTSingleGrid(), and pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint().

## max_

template<typename PointT >

Eigen::Vector2f pcl::ndt2d::NDTSingleGrid< PointT >::max_

protected

Definition at line 291 of file ndt_2d.hpp.

## min_

template<typename PointT >

Eigen::Vector2f pcl::ndt2d::NDTSingleGrid< PointT >::min_

protected

Definition at line 290 of file ndt_2d.hpp.

Referenced by pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint().

## normal_distributions_

template<typename PointT >

Eigen::Matrix<NormalDist, Eigen::Dynamic, Eigen::Dynamic> pcl::ndt2d::NDTSingleGrid< PointT >::normal_distributions_

protected

Definition at line 295 of file ndt_2d.hpp.

Referenced by pcl::ndt2d::NDTSingleGrid< PointT >::NDTSingleGrid(), and pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint().

## step_

template<typename PointT >

Eigen::Vector2f pcl::ndt2d::NDTSingleGrid< PointT >::step_

protected

Definition at line 292 of file ndt_2d.hpp.

Referenced by pcl::ndt2d::NDTSingleGrid< PointT >::normalDistForPoint().

The documentation for this class was generated from the following file:

- pcl/registration/impl/ndt_2d.hpp